import java.io.IOException;
import java.net.URL;
import java.util.ResourceBundle;
import java.util.logging.Level;
import java.util.logging.Logger;

import javafx.beans.binding.Bindings;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.stage.Modality;
import javafx.stage.Stage;

public class Controller implements Initializable {
	@FXML
	public Label valueLabel;
	private FXMLApp app;
	private Model model;

	@FXML
	public void increase(ActionEvent event) {
		model.increase();
	}

	@FXML
	public void showAboutDialog(ActionEvent event) {
		try {
			Stage aboutStage = FXMLLoader.load(getClass().getResource(
					"About.fxml"));
			aboutStage.initModality(Modality.WINDOW_MODAL);
			aboutStage.initOwner(app.getStage());
			aboutStage.show();
		} catch (IOException e) {
			Logger.getLogger(Comparable.class.getName()).log(Level.SEVERE,
					e.getMessage(), e);
		}
	}

	@Override
	public void initialize(URL location, ResourceBundle resources) {
		valueLabel.setText("Hello from Code!");
		app = FXMLApp.getInstance();
		model = app.getModel();
		valueLabel.textProperty().bind(
				Bindings.format("Value: %s", model.counterProperty()));
	}
}
